#!/bin/bash
# GPL, mimooh at pld-linux.org
# bootsplash

run_main() {
	[ -n "$kernel" ] || { show_message "Musisz wybra wersj jdra"; exit; }
	install_if_missing "bootsplash psmisc" #killall is needed
	line_replace "BOOT_SPLASH_RESOLUTIONS" "BOOT_SPLASH_RESOLUTIONS=$resolution" $CONF_FILE
	line_replace "THEME" "THEME=$theme" $CONF_FILE
	line_replace "BOOT_SPLASH_CONSOLES" "BOOT_SPLASH_CONSOLES=\"$consoles\"" $CONF_FILE
	geninitrd -v -f /boot/geninitrd-$kernel.gz $kernel
	show_message "OK"
}

gui () { 
	kernels_set=`ls /boot/ | grep vmlinuz- | sed -e 's/vmlinuz-//;s/.*/<item id=&>&/'`
	echo "$(nls "Looking for installed bootsplash-theme...")"
	themes_set=`rpm -qa | grep bootsplash-theme | sed -e 's/bootsplash-theme-//;s/-.*//;s/.*/<item id=&>&/'`

	eval `dml<< EOF
<meta title="$(nls "bootsplash - graphics during boot")"><br><br>
<button id=install_themes caption="$(nls "Install bootsplash-theme*")"<br><br><br><br>
$(nls "Bootsplash theme"): 
<menu hidden=1 id=theme_hidden>
$themes_set
</menu>
<br><input id=theme menu=theme_hidden width=20><br><br>

Rozdzielczo (zgodnie z "Tryb frambuffer" w pldconf -b):
<menu hidden=1 id=resolution_hidden>
<item id=1024x768>1280x1024 vga=0x31A
<item id=1024x768>1024x768 vga=0x317
<item id=800x600>800x600 vga=0x314
<item id=640x480>640x480 vga=0x311
</menu>
<br><input id=resolution menu=resolution_hidden width=15><br><br>
Bootsplash na konsolach:<br>
<input id=consoles caption="0 1 2" width=20><br><br>

Wersja jdra (tylko seria 2.6):
<menu hidden=1 id=kernel_hidden>
$kernels_set
</menu>
<br><input id=kernel menu=kernel_hidden width=15><br><br>

\`dml_buttons Ok Anuluj Edytuj Pomoc\`


EOF`

	[ "X$install_themes" = "Xyes" ] && { poldek -Uv bootsplash-theme*; gui; }
	dml_cancel_check ${DATA_DIR}/BOOT/boot_menu.sh
	dml_edit_check /etc/sysconfig/bootsplash
	dml_help_check ${DATA_DIR}/POMOC/README_bootsplash.txt
	dml_check_the_rest ${DATA_DIR}/BOOT/boot_menu.sh
}

CONF_FILE=/etc/sysconfig/bootsplash
gui 
