#!/bin/bash
#
# poldek.sh	Module for instaling programs, useful for beginer users
# 
# Author:	Karol Kreski <mimooh at pld-linux.org>
# Changes:	Jakub Krajniak <teodor at pld-linux.org>
# Licence:	GPL
# 
# $Id:$
#

install_selected () {
	packets_list="`echo $packets_list|sed -e 's/xxx//g'`" #Remove group entries
	for i in $packets_list; do
		case $i in 
			#Nvidia driver grrr
			x) packets="$packets XFree86 XFree86-tools xinitrc XFree86-driver-*";;
			x_fonts) packets="$packets XFree86-fonts XFree86-fonts-ISO8859-2 XFree86-fonts-75dpi-ISO8859-2 XFree86-fonts-100dpi-ISO8859-2";;
			x_nv) packets="$packets XFree86 XFree-driver-nvidia XFree86-tools xinitrc";;
			KDE) packets="$packets kdebase-desktop";;
			xfwm4) packets="$packets xfce4-panel xfwm4 xfce-utils xfce4-mixer xfce4-battery-plugin";;
			gnome) packets="$packets metacity gnome-session gnome-desktop gnome-panel";;
			bmp) packets="$packets beep-media-player beep-media-player-input-cdaudio beep-media-player-input-mpg123 beep-media-player-input-vorbis beep-media-player-output-OSS beep-media-player-output-alsa";;
			xmms) packets="$packets xmms xmms-input-cdaudio xmms-input-mpg123 xmms-input-vorbis xmms-input-wav xmms-output-OSS xmms-output-ALSA";;
			info) packets="$pakets pciutils less nmap";;
			devel) packets="$packets kernel-headers glibc-devel gcc autoconf automake libstdc++-devel subversion cvs";;
			samba) packets="$packets samba samba-client";;
			printer) packets="$packets cups cups-client";;
			system_boot) packets="$packets grub chkconfig";;
			speedtouch) packets="$packets speedtouch ppp ppp-plugin-pppoatm";;
			modem) packets="$packets ppp wvdial ppplicznik";;
			gg) packets="$packets gg2 gg2-gadu-gadu gg2-tlen gg2-sms gg2-jabber";;
			*) packets="$packets $i";;
		esac
	done
}

run_main ()
{
	[ "X$poldek_conf" = "Xyes" ] && exec ${DATA_DIR}/poldek_conf.sh
	[ "X$poldek_shell" = "Xyes" ] && exec /usr/bin/poldek
	[ "X$sync" = "Xyes" ] && exec /usr/bin/poldek --upa
	[ "X$poldek_fetch" = "Xyes" ] && poldek --shcmd="get $poldek_file_fetch"
	[ -n "$packets_list" ] && { install_selected; install_packets "$packets"; }
}

gui()
{
	eval `dml<< EOF
	<meta title="$(nls "Add/remove programs")" width=70><br>
	<button id="poldek_conf" caption="$(nls "Setup")"> <button id="poldek_shell" caption="$(nls "Add/remove programs")"> <button id="sync" caption="$(nls "Synchronize index")"><br>
	------------------------------------------------------------------<br>
	$(nls "Using poldek, install packages for this sections:")<br>
	<menu id=packets_list height=15>
	<item id=xxx ghosted=0>$(nls "Editors")
	<item id=vim checked=0> vim
	<item id=joe checked=0> joe
	<item id=mc checked=0> mcedit
	<item id=pico checked=0> pico
	<item id=nano checked=0> nano
	<item id=jed checked=0> jed
	<item id=xxx ghosted=1>XFree
	<item id=xxx ghosted=1>  $(nls "X drivers:")
	<item id=x group=x_driver checked=0> $(nls "All drviers")
	<item id=x_nvidia group=x_driver checked=0> $(nls "NVidia drvier")
	<item id=x_fonts checked=0> $(nls "Fonts")
	<item id=xxx ghosted=1>$(nls "Window managers")
	<item id=xfwm4 checked=0> xfwm4
	<item id=wmaker checked=0> WindowMaker
	<item id=icewm checked=0> IceWM
	<item id=fluxbox checked=0> Fluxbox
	<item id=kde checked=0> KDE
	<item id=gnome checked=0> GNOME
	<item id=xxx ghosted=0>$(nls "Basic applications")
	<item id="mozilla-firefox" checked=0> Mozilla Firefox
	<item id=mozilla checked=0> Mozilla
	<item id=slrn-pl checked=0> Slrn-pl ($(nls "news client"))
	<item id=mutt checked=0> Mutt ($(nls "mail client"))
	<item id=ekg checked=0> EKG ($(nls "client for GG network - console"))
	<item id=gg checked=0> GNU Gadu ($(nls "multicomunicator (tlen,gg,jabber networks)"))
	<item id=xchat checked=0> xchat (IRC)
	<item id=rox checked=0> ROX ($(nls "file manager"))
	<item id=FreeIconsProject checked=0> FreeIcons ($(nls "nice icons"))
	<item id=gimp checked=0> GIMP
	<item id=blender checked=0> Blender
	<item id=qcad checked=0> QCad
	<item id=gqview checked=0> gqview ($(nls "image viewer"))
	<item id=bmp checked=0> Beep media player
	<item id=xmms checked=0> XMMS
	<item id=mplayer checked=0> mplayer
	<item id=LinNeighborhood checked=0> LinNeighborgooh - $(nls "SAMBA viewer")
	<item id=system_boot checked=0>$(nls "System booting") (grub/chkconfig)
	<item id=samba checked=0>$(nls "SAMBA package")
	<item id=printer checked=0>$(nls "CUPS package for system printing")
	<item id=xxx ghosted=1>$(nls "Comunication")
	<item id=seedtouch checked=0> Neostrada Speedtouch
	<item id=modem checked=0> Modem/SDI
	<item id=iptables checked=0> Firewall
	<item id=xxx ghosted=1>$(nls "Other")
	<item id=sudo checked=0> sudo
	<item id=rdate checked=0> rdate
	<item id=psmisc checked=0> psmisc
	<item id=man checked=0> man
	<item id=pinfo checked=0> pinfo
	<item id=slocate checked=0> slocate
	<item id=info checked=0>$(nls "About system") (pciutils/less/nmap)
	<item id=devel checked=0>$(nls "Devel packages") (gcc & friends)
	</menu>
	<button id=instaluj caption="$(nls "Install selected")"><br>
	<button id=poldek_fetch caption=$(nls "Download")> $(nls "package") <input id=poldek_file_fetch caption=coreutils width=16>.rpm
	<br>$(nls "Show description selected packages") <button id=info caption=Ok>
	<br>------------------------------------------------------------------<br>
	\`dml_buttons Anuluj Pomoc Wyjcie\`
EOF`

	[ "X$poldek_conf" = "Xyes" ] && exec ${DATA_DIR}/poldek_conf.sh
	if [ "X$poldek_shell" = "Xyes" ] || [ "X$sync" = "Xyes" ] || [ "X$instaluj" = "Xyes" ] \
		|| [ "X$inst_all" = "Xyes" ]  || [ "$poldek_fetch" = "Xyes" ]; then
		dml_ok="yes"
	fi
	dml_cancel_check ${EXEC_PREFIX}/pldconf
	dml_help_check ${DATA_DIR}/POMOC/README_poldek.txt
	dml_check_the_rest ${EXEC_PREFIX}/pldconf
}

print_help()
{
	cat << EOF
$(nls "Options"):
-s   $(nls "synchronize indexes");
-a   $(nls "install all");
-e   $(nls "install editors");
-X   $(nls "install X section");
-N   $(nls "install original nvidia driver");
-d   $(nls "install Desktop section");
-S   $(nls "install SAMBA section");
-b   $(nls "install Boot section");
-k   $(nls "install Killer desktop! section");
-n   $(nls "install Network section");
-p   $(nls "install Printer section");
-I   $(nls "install Other section");
-o   $(nls "install About system section");
-c   $(nls "install devel packages");
-i   $(nls "install packages from comandline. Use qutation if you install
more than one package eg.") -i "rox mozilla gimp"
-f <$(nls "package")>  $(nls "download packages to current director");
-h   $(nls "help");
$(nls "no options run GUI")
EOF
}

while getopts "saeXNdSbknpIoci:f:h" opt
do
	case $opt in
		s ) sync="yes";;
		a ) inst_all="yes";;
		e ) packets_list="$packets_list jed vim mc";;
		X ) packets_list="$packets_list x x_fonts";;
		N ) packets_list="$packets_list x_nv x_fonts";;
		d ) packets_list="$packets_list xfwm4 WindowMaker icewm fluxbox";;
		S ) packets_list="$packets_list printer";;
		b ) packets_list="$packets_list system_boot";;
		k ) packets_list="$packets_list mozilla rox gimp mplayer bmp xmms mutt FreeIconsProject ";;
		n ) packets_list="$packets_list speedtouch modem iptables";;
		p ) packets_list="$packets_list printer";;
		I ) packets_list="$packets_list sudo rdate psmisc man pinfo";;
		o ) packets_list="$packets_list info";;
		c ) packets_list="$packets_list devel";;
		i ) packets_list="$OPTARG";;
		f ) poldek_file_fetch=$OPTARG; poldek_fetch="yes";;
		h ) print_help; exit;; 
		? ) print_help; exit;; 
	esac
done

[ -z "$1" ] && gui || run_main 2>/dev/null
